'入力ﾃﾞｰﾀﾌｧｲﾙの読み込みﾌﾟﾛｸﾞﾗﾑ
Imports System.IO

Public Class AnalDat6
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents OpenFileDialog1 As System.Windows.Forms.OpenFileDialog
    Friend WithEvents SaveFileDialog1 As System.Windows.Forms.SaveFileDialog
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.OpenFileDialog1 = New System.Windows.Forms.OpenFileDialog()
        Me.SaveFileDialog1 = New System.Windows.Forms.SaveFileDialog()
        '
        'SaveFileDialog1
        '
        Me.SaveFileDialog1.FileName = "doc1"
        '
        'AnalDat6
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Name = "AnalDat6"
        Me.Text = "AnalDat6"

    End Sub

#End Region

    Sub AnIsoThermFileInU(ByVal fxx$, ByRef kh As Integer)
        'AnIsoThermﾌｧｲﾙの読み込み
        'UTF-8･･･BOMなし
        'fxx$･･･入力ﾌｧｲﾙ名
        'kh･･･ｴﾗｰ有無（0:なし、-1:有り）
        Dim aa$
        Dim i, j, nmax As Integer

        kh = 0
        Dim sr As New IO.StreamReader(fxx$)
        Dim dat() As String

        aa$ = sr.ReadLine
        dat = aa.Split(",")
        If dat(0) <> "プログラム名" Then
            aa$ = "本ソフトのUTF-8データファイルとは違います！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            sr.Close()
            Exit Sub
        End If
        If dat(1) <> "AnIsoTherm" Then
            aa$ = "データファイルが違います！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            sr.Close()
            Exit Sub
        End If
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        KindElem = dat(1)
        If KindElem = 0 Then
            nmax = 20
        Else
            aa$ = "六面体要素以外は使用できません！"
            MsgBox(aa$, 0, "データエラー")
            kh = -1
            sr.Close()
            Exit Sub
        End If
        Title$ = sr.ReadLine
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Npoint = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nelem = dat(1)
        aa$ = sr.ReadLine
        dat = aa.Split(",")
        Nmat = dat(1)

        ReDim NNelem(Nelem, 20), NumMat(Nelem)
        ReDim Xdata(Npoint), Ydata(Npoint), Zdata(Npoint)

        Do
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            If dat(0) = "初期値データの有無" Then
                Exit Do
            End If
        Loop

        aa$ = sr.ReadLine
        For i = 1 To Nelem
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            NumMat(i) = dat(1)
            For j = 1 To 10
                NNelem(i, j) = dat(j + 1)
            Next j
            If nmax > 10 Then
                aa$ = sr.ReadLine
                dat = aa.Split(",")
                For j = 11 To nmax
                    NNelem(i, j) = dat(j - 11)
                Next j
            End If
        Next i

        aa$ = sr.ReadLine
        For i = 1 To Npoint
            aa$ = sr.ReadLine
            dat = aa.Split(",")
            Xdata(i) = dat(1)
            Ydata(i) = dat(2)
            Zdata(i) = dat(3)
        Next i

        sr.Close()

        NboundP = 0
        NboundS = 0
        Nforce = 0
        NforceA = 0
        Nsurf = 0
        Nspring = 0
        KindGrav = 0
        KindRevF = 0
        Ndim = 3
        Mprop = 10
        Ngaus = 3
        ReDim SpecWeight(Nmat)
        ReDim EJoung(Nmat, 3), Gshear(Nmat, 3), Rnyu(Nmat, 3)

    End Sub

    Private Sub DfileIn()
        '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み実行
        Dim aa$, fxb$
        Dim kh As Integer

        fxb$ = ""
        If Koption(1) > 0 Then
            Call FileName(Fm$, fxb$)
            'ﾌｧｲﾙ名Fm$の拡張子なしの部分fxb$を取得
            fxb$ = fxb$ + ".bak"
            If File.Exists(fxb$) Then
                File.Delete(fxb$)
            End If
            File.Copy(Fm$, fxb$)
        End If
        kh = 0
        Try
            Call DfileInputU(Fm$)    '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み
            KdataChange = 0
        Catch ex As Exception
            kh = -1
        End Try
        If kh < 0 Then
            KfileOK = 0
            aa$ = "入力データファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        End If

    End Sub

    Private Sub DfileIn2()
        'AnIsoThermﾌｧｲﾙの読み込み実行
        Dim aa$, fxb$
        Dim ii, kh As Integer

        fxb$ = ""
        Call FileName(Fm$, fxb$)    'ﾌｧｲﾙ名Fm$の拡張子なしの部分fxb$を取得
        kh = 0
        Try
            Call AnIsoThermFileInU(Fm$, kh)  'AnIsoThermﾌｧｲﾙの読み込み
            If kh < 0 Then
                Exit Sub
            End If
        Catch ex As Exception
            FileClose(ii)
            kh = -1
        End Try

        If kh < 0 Then
            KfileOK = 0
            aa$ = "入力データファイルを読み込めません！"
            MsgBox(aa$, 0, "ファイルエラー")
            Me.Close()
        ElseIf kh = 0 Then
            KdataChange = 1
            Fm$ = fxb$ + "F.dat"
            aa$ = "AnIsoThermファイルをAnIsoFEMファイルに変換しました。"
            aa$ = aa$ + Cr$ + "保存が必要です!"
            MsgBox(aa$, 0, "ファイル変換終了")
        End If

    End Sub

    Private Sub OpenFileDialog1_FileOk(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles OpenFileDialog1.FileOk
        KfileOK = 1

    End Sub

    Private Sub SaveFileDialog1_FileOk(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles SaveFileDialog1.FileOk
        KfileOK = 1

    End Sub

    Private Sub AnalDat6_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$
        If Fm$ = "" Then
            Call TmpFileIn() 'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ読み込み
        End If

        KfileOK = 0
        If InOut = 0 Or InOut = 2 Then
            aa$ = "すべてのファイル(*.*)|*.*|データファイル(*.dat)|*.dat"
            OpenFileDialog1.Filter = aa$
            OpenFileDialog1.FilterIndex = 2
            OpenFileDialog1.FileName = Fm$
            OpenFileDialog1.ShowDialog()
            If KfileOK > 0 Then
                Fm$ = OpenFileDialog1.FileName
                Try
                    Dim sr As New IO.StreamReader(Fm$)
                    sr.Close()
                Catch
                    KfileOK = 0
                    MsgBox("指定されたデータファイルが開けません！", 0, "オープンエラー")
                    Me.Close()
                End Try
            End If
        Else
            aa$ = "すべてのファイル(*.*)|*.*|データファイル(*.dat)|*.dat"
            SaveFileDialog1.Filter = aa$
            SaveFileDialog1.FilterIndex = 2
            SaveFileDialog1.FileName = Fm$
            SaveFileDialog1.CreatePrompt = True     '書込可能性ﾁｪｯｸ
            SaveFileDialog1.OverwritePrompt = True  '上書注意表示
            SaveFileDialog1.ShowDialog()
            If KfileOK > 0 Then
                Fm$ = SaveFileDialog1.FileName
            End If
        End If

        If KfileOK > 0 Then
            Select Case InOut
                Case 0
                    Call DfileIn()      '入力ﾃﾞｰﾀﾌｧｲﾙの読み込み実行
                Case 1
                    Call DfileOutU(Fm$)  '入力ﾃﾞｰﾀﾌｧｲﾙへの書き出し
                    KdataChange = 0
                Case 2
                    Call DfileIn2()     'AnIsoThermﾃﾞｰﾀﾌｧｲﾙの読み込み実行
            End Select
            If Fm$ <> UFileA(1) Then
                UFileA(0) = Fm$
                UFileAddA()     'UFileAの追加処理
                KnewUFileA = 1
            End If
            Fy$ = ""
            Call TmpFileOut() 'ﾃﾝﾎﾟﾗﾘｰ･ﾌｧｲﾙ書き出し
        End If

        Me.Close()

    End Sub
End Class
